Debian Bug report logs - #692312
nodejs package is out-of-date

version graph

Package: nodejs; Maintainer for nodejs is Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>; Source for nodejs is src:nodejs.

Reported by: C Snover <debian-bugs@zetafleet.com>

Date: Sun, 4 Nov 2012 21:51:02 UTC

Severity: wishlist

Merged with 694729

Found in versions nodejs/0.6.19~dfsg1-5, nodejs/0.6.19~dfsg1-6

Done: "Jean-Michel Vourgère" <jmv_deb@nirgal.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Sun, 04 Nov 2012 21:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to C Snover <debian-bugs@zetafleet.com>:
New Bug report received and forwarded. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Sun, 04 Nov 2012 21:51:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: C Snover <debian-bugs@zetafleet.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: nodejs package is out-of-date
Date: Sun, 04 Nov 2012 21:19:04 +0000
Package: nodejs
Version: 0.6.19~dfsg1-5
Severity: important

Dear Maintainer,

The current upstream version of nodejs is 0.8.14, but the version
currently packaged for Debian is 0.6.19. There are some API
changes between these versions that prevent new nodejs packages
from functioning with the version of nodejs currently provided by
Debian. At this point, I am required to either install from an
Ubuntu PPA or compile from source in order to use nodejs on
Debian.

Please consider updating the currently packaged version to the
latest upstream release.

Thanks for your hard work!

Regards,

-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (500, 'testing'), (300, 'experimental'), (300, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 3.2.0-2-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

-- no debconf information



Severity set to 'wishlist' from 'important' Request was from Dominique Dumont <dod@debian.org> to control@bugs.debian.org. (Mon, 03 Dec 2012 12:15:03 GMT) Full text and rfc822 format available.

Marked as found in versions nodejs/0.6.19~dfsg1-6. Request was from Dominique Dumont <dod@debian.org> to control@bugs.debian.org. (Mon, 03 Dec 2012 13:03:12 GMT) Full text and rfc822 format available.

Merged 692312 694729 Request was from Dominique Dumont <dod@debian.org> to control@bugs.debian.org. (Mon, 03 Dec 2012 13:03:13 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Thu, 03 Jan 2013 20:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ruben Herold <ruben@puettmann.net>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Thu, 03 Jan 2013 20:45:03 GMT) Full text and rfc822 format available.

Message #16 received at 692312@bugs.debian.org (full text, mbox):

From: Ruben Herold <ruben@puettmann.net>
To: 692312@bugs.debian.org
Subject: nodejs package still out-of-date
Date: Thu, 3 Jan 2013 21:27:07 +0100
[Message part 1 (text/plain, inline)]
Dear Maintainer,

The current upstream version of nodejs is 0.8.16, but the version
currently packaged for Debian is 0.6.19~dfsg1-6. This makes nodejs in
Debian nearly unuseable....


        Ruben

        
-- 
Ruben Herold 
ruben@puettmann.net
http://www.puettmann.net
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Thu, 03 Jan 2013 21:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to 692312@bugs.debian.org:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Thu, 03 Jan 2013 21:57:03 GMT) Full text and rfc822 format available.

Message #21 received at 692312@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: Ruben Herold <ruben@puettmann.net>, 692312@bugs.debian.org
Subject: Re: [Pkg-javascript-devel] Bug#692312: nodejs package still out-of-date
Date: Thu, 03 Jan 2013 22:55:32 +0100
[Message part 1 (text/plain, inline)]
Hi Ruben,

Quoting Ruben Herold (2013-01-03 21:27:07)
> The current upstream version of nodejs is 0.8.16, but the version 
> currently packaged for Debian is 0.6.19~dfsg1-6. This makes nodejs in 
> Debian nearly unuseable....

Above seems almost identical to the original bugreport: Please note that 
our bugtracker is not a voting engine - "me too" emails won't help get 
any work done.

Personally I find the currently packaged version of Nodejs quite usable, 
so it _might_ help elaborating what more detailed renders is useless for 
you.


Regards,

 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Fri, 04 Jan 2013 09:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to dod@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Fri, 04 Jan 2013 09:21:05 GMT) Full text and rfc822 format available.

Message #26 received at 692312@bugs.debian.org (full text, mbox):

From: Dominique Dumont <dod@debian.org>
To: 692312@bugs.debian.org
Subject: Re: [Pkg-javascript-devel] Bug#692312: Bug#692312: nodejs package still out-of-date
Date: Fri, 4 Jan 2013 10:17:25 +0100
On Thursday 03 January 2013 22:55:32 Jonas Smedegaard wrote:
> Personally I find the currently packaged version of Nodejs quite usable, 
> so it might help elaborating what more detailed renders is useless for 
> you.

On my side, I need nodejs 0.8 to work on Ares project [1], so I've compiled my 
own package from Debian nodejs package repo.

That said, Ares is outside of Debian...

HTH

[1] https://github.com/enyojs/ares-project

-- 
 https://github.com/dod38fr/   -o- http://search.cpan.org/~ddumont/
http://ddumont.wordpress.com/  -o-   irc: dod at irc.debian.org



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Mon, 14 Jan 2013 20:15:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Rick Waldron <waldron.rick@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Mon, 14 Jan 2013 20:15:05 GMT) Full text and rfc822 format available.

Message #31 received at 692312@bugs.debian.org (full text, mbox):

From: Rick Waldron <waldron.rick@gmail.com>
To: 692312@bugs.debian.org
Cc: paultag@debian.org
Date: Mon, 14 Jan 2013 15:09:42 -0500
[Message part 1 (text/plain, inline)]
It's strange to me this is even an issue that's being argued, I would
assume that a Debian package maintainer would be responsible enough to keep
up with the latest stable releases of whatever they have taken on to
maintain.

Back in the real-world, the biggest problem is that 0.6 and 0.8 use
completely different build systems, replacing waf with gyp (both for
building node and native modules). I'm sure you can appreciate and respect
the depth of this problem alone.

Please review the changes (published 6 months ago):
https://github.com/joyent/node/wiki/API-changes-between-v0.6-and-v0.8

Rick
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Mon, 14 Jan 2013 20:30:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Tagliamonte <paultag@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Mon, 14 Jan 2013 20:30:06 GMT) Full text and rfc822 format available.

Message #36 received at 692312@bugs.debian.org (full text, mbox):

From: Paul Tagliamonte <paultag@debian.org>
To: Rick Waldron <waldron.rick@gmail.com>, 692312@bugs.debian.org
Subject: Re: [Pkg-javascript-devel] Bug#692312:
Date: Mon, 14 Jan 2013 15:33:41 -0500
[Message part 1 (text/plain, inline)]
On Mon, Jan 14, 2013 at 03:09:42PM -0500, Rick Waldron wrote:
>    It's strange to me this is even an issue that's being argued, I would
>    assume that a Debian package maintainer would be responsible enough to
>    keep up with the latest stable releases of whatever they have taken on to
>    maintain.
>    Back in the real-world, the biggest problem is that 0.6 and 0.8 use
>    completely different build systems, replacing waf with gyp (both for
>    building node and native modules). I'm sure you can appreciate and respect
>    the depth of this problem alone.
>    Please review the changes (published 6 months ago):
>    [1]https://github.com/joyent/node/wiki/API-changes-between-v0.6-and-v0.8

Just read through these -- there are some seriously breaking changes
new upstream releases of our node modules must be writing against this
API, I'd argue keeping nodejs back holds our packaged node apps pretty
badly.

I mean, literally anything that touches the filesystem ...

>    Rick
> 
> References
> 
>    Visible links
>    1. https://github.com/joyent/node/wiki/API-changes-between-v0.6-and-v0.8

> _______________________________________________
> Pkg-javascript-devel mailing list
> Pkg-javascript-devel@lists.alioth.debian.org
> http://lists.alioth.debian.org/cgi-bin/mailman/listinfo/pkg-javascript-devel


Fondly,
  Paul

-- 
 .''`.  Paul Tagliamonte <paultag@debian.org>
: :'  : Proud Debian Developer
`. `'`  4096R / 8F04 9AD8 2C92 066C 7352  D28A 7B58 5B30 807C 2A87
 `-     http://people.debian.org/~paultag
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Mon, 14 Jan 2013 20:51:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonas Smedegaard <dr@jones.dk>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Mon, 14 Jan 2013 20:51:10 GMT) Full text and rfc822 format available.

Message #41 received at 692312@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: 692312@bugs.debian.org
Subject: Re: [Pkg-javascript-devel] Bug#692312:
Date: Mon, 14 Jan 2013 21:46:53 +0100
[Message part 1 (text/plain, inline)]
Quoting Rick Waldron (2013-01-14 21:09:42)
> It's strange to me this is even an issue that's being argued, I would 
> assume that a Debian package maintainer would be responsible enough to 
> keep up with the latest stable releases of whatever they have taken on 
> to maintain.
> Back in the real-world, the biggest problem is that 0.6 and 0.8 use 
> completely different build systems, replacing waf with gyp (both for 
> building node and native modules). I'm sure you can appreciate and 
> respect the depth of this problem alone.
> Please review the changes (published 6 months ago):
> [1]https://github.com/joyent/node/wiki/API-changes-between-v0.6-and-v0.8�

If the purpose of above was to contribute to move this bugreport 
forward, then you failed: It is not at all helpful to educate on how 
irresponsible maintainers are, how much of a dreamworld they live in, or 
for how long new upstream release have been out.

If the purpose was to provoke, then you succeeded.  Happy now?

What would help is elaborate on what renders Nodejs 0.6 branch unusable.

There is currently code in Debian that will potentially be rendered 
unusable by the upgrade, so it would be nice to know what would be the 
gain compared to such potential extra burden.


 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Mon, 14 Jan 2013 21:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jérémy Lal <kapouer@melix.org>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Mon, 14 Jan 2013 21:33:03 GMT) Full text and rfc822 format available.

Message #46 received at 692312@bugs.debian.org (full text, mbox):

From: Jérémy Lal <kapouer@melix.org>
To: 692312@bugs.debian.org
Subject: Re: Bug#692312: [Pkg-javascript-devel] Bug#692312:
Date: Mon, 14 Jan 2013 22:29:37 +0100
[Message part 1 (text/plain, inline)]
On 14/01/2013 21:46, Jonas Smedegaard wrote:
> Quoting Rick Waldron (2013-01-14 21:09:42)
>> It's strange to me this is even an issue that's being argued, I would 
>> assume that a Debian package maintainer would be responsible enough to 
>> keep up with the latest stable releases of whatever they have taken on 
>> to maintain.
>> Back in the real-world, the biggest problem is that 0.6 and 0.8 use 
>> completely different build systems, replacing waf with gyp (both for 
>> building node and native modules). I'm sure you can appreciate and 
>> respect the depth of this problem alone.
>> Please review the changes (published 6 months ago):
>> [1]https://github.com/joyent/node/wiki/API-changes-between-v0.6-and-v0.8�
> 
> If the purpose of above was to contribute to move this bugreport 
> forward, then you failed: It is not at all helpful to educate on how 
> irresponsible maintainers are, how much of a dreamworld they live in, or 
> for how long new upstream release have been out.
> 
> If the purpose was to provoke, then you succeeded.  Happy now?
> 
> What would help is elaborate on what renders Nodejs 0.6 branch unusable.
> 
> There is currently code in Debian that will potentially be rendered 
> unusable by the upgrade, so it would be nice to know what would be the 
> gain compared to such potential extra burden.

I agree with Jonas that there is no kind of urgency in updating nodejs.
Please ignore provocations like Rick Waldron does. He has even brought
that matter upstream [0].

It's a lot of work to do again, and i wish i could do it at once.
Here's what i propose (mind that all will go to experimental during freeze) :

Can be quickly done :
* update libv8 (maybe 3.15.11.x)
* update nodejs to 0.8

Takes time :
* package missing node-gyp deps, update npm deps
* package node-gyp 0.8.2

Rather quick once that is done :
* update npm to 1.2.0

Note that i'm not pledging for someone to do that - it's my intention
to do it. Helping will only make it happen sooner.


Regards,
Jérémy


[0]
https://groups.google.com/forum/#!topic/nodejs/W_6avRSG_a8


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Mon, 14 Jan 2013 21:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Forrest L Norvell <ogd@aoaioxxysz.net>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Mon, 14 Jan 2013 21:48:03 GMT) Full text and rfc822 format available.

Message #51 received at 692312@bugs.debian.org (full text, mbox):

From: Forrest L Norvell <ogd@aoaioxxysz.net>
To: 692312@bugs.debian.org
Subject: features missing from 0.6.x
Date: Mon, 14 Jan 2013 13:35:50 -0800
Hello!

Here are some of the important changes between 0.6 and 0.8:

* replaced the node-waf build system with gyp. This greatly simplifies the
  process of building multiplatform extensions and is the currently supported
  mechanism for publishing modules with architecture-specific binary components.
  waf has been strongly deprecated upstream
* added much better support for localized error handling in the form of domains
  (http://nodejs.org/api/domain.html)
* included numerous fixes to TLS and SSL support that have not been backported
  to the (now de facto end-of-life) 0.6.21
* added access to a significant number of new JavaScript language features
  (exposed via the --harmony comand-line flag) due to being built against a newer
  version of V8
* made significant improvements to the cluster and child_process core modules
  (involving how data is passed between processes and how file descriptors are
  handled) that make working with subsidiary processes more straightforward and
  less error-prone
* perhaps least significantly (but something I use all over the place in the
  code I support), there is a new timer function in process.hrtime() that has
  nanosecond precision (if not accuracy)

There are also many, many minor bug fixes and tweaks between the two at an
operational level, and given that npm allows modules to specify what version of
core they'll run against, there are many modules on npm (sorry, don't have an
exact number for you, but I can get it if it's important) that will simply not
work with the version of Node packaged for Debian.

Taking a step back, upstream is getting very close to releasing 0.10, and given
that it includes a newer, rationalized version of Node's support for streams,
is going to result in a tremendously large delta between 0.6 and 0.10.

As it stands, the version of Node distributed with Debian is unusable for me,
and I regularly help confused Debian users on #node.js on Freenet either get up
and running with Chris Lea's PPA (which is for a different distribution)
because the version included with Node is too old for them as well.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Mon, 14 Jan 2013 21:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bradley Meck <bradley.meck@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Mon, 14 Jan 2013 21:57:03 GMT) Full text and rfc822 format available.

Message #56 received at 692312@bugs.debian.org (full text, mbox):

From: Bradley Meck <bradley.meck@gmail.com>
To: 692312@bugs.debian.org
Subject: Clarification on problems maintaining 0.6.x packages in the Node ecosystem.
Date: Mon, 14 Jan 2013 15:52:11 -0600
[Message part 1 (text/plain, inline)]
This issue seems to be getting a little muddled,

Rick was pointing to issues that would affect relying on newer packages of
Node.js for existing code bases that target 0.6.x; however as Node Package
Manager (NPM) modules continue to evolve, in particular, and target the
newer versions of node certain aspects become difficult to maintain for a
0.6.x author.

These issues involve:

1. Lack of support for some problems when using the WAF build system (and
the purpose of moving to gyp covered in detail on node.js' mailing lists)
2. Misleading module support, due to default engine version. (see: `npm
help json`'s engines field)
3. Documentation issues, missing direct links to docs on the
nodejs.orgwebsite due to 0.8.x being the recommended stable release
(use google to
find em instead, and even then pick the right one?).
4. Various bug fixes that are not back ported.

These do not break any existing code for node@0.6.x, however, they could
introduce problems with maintenance, bug fixes, support, security, etc.

Removing 0.6.x would be a problematic situation since there are breaking
API changes, but it appears the original goal of this conversation was to
include a 0.8.x package more than to remove the 0.6.x package entirely. I
personally do not use the packages, but wished to clarify this since it
seems to be terse conversation that leads to confusion on both ends.

Jonas and Paul, can you clarify why those reasons are not encouraging,
and/or a way to rephrase the original intent of the issue in a manner that
is appropriate? It seems if a fork of 0.6.x was maintained and kept up to
date with all the bug fixes this would be appropriate, but as documentation
fixes and code fixes are not being back ported to 0.6.x it would be
encouraging to know the route to take this issue. We have little wish to
change your existing code, but would like to take the proper steps to
update the package to a new version for both current and future reference.

Thans for your patience,
Bradley Meck
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Wed, 16 Jan 2013 00:15:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "David I. Lehn" <dlehn@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Wed, 16 Jan 2013 00:15:04 GMT) Full text and rfc822 format available.

Message #61 received at 692312@bugs.debian.org (full text, mbox):

From: "David I. Lehn" <dlehn@debian.org>
To: 692312@bugs.debian.org
Subject: Issues updating nodejs
Date: Tue, 15 Jan 2013 19:12:17 -0500
I would also like to see nodejs updated and have been working on it a bit.

I'm kind of amazed that anyone would have to justify upgrading an
ancient release because obviously it has to been done at some point.
Sooner rather than later I say.  My reasons are performance and newer
APIs and docs:

* Newer V8 has performance optimizations that are useful for workloads I have.
* Various newer APIs would also be useful such as timing and cluster
module and others.
* Better debugging support for native extension loading issues.
* The node.js homepage shows docs for the stable 0.8.x release.  It's
kind of tricky to find the docs for the old 0.6.x series Debian uses.
This leads to confusion.

I've been experimenting updating nodejs to 0.8.x and 0.9.x branches.
Along the way I hit a number of issues and problems:

* Recent npm and 0.8.x+ now uses node-gyp to compile native extensions.
* node-gyp by default compiles extensions by downloading the upstream
nodejs source and extracting headers into ~/.node-gyp/0.x.y/ and
compiling against that.  (I hear node-gyp has some nodedir magic
option but I have no clue how to use it and can't find docs or code to
help.)
* The above means that node + node-gyp now REQUIRES nodejs to be built
against the version of V8 that is shipped with whatever version of
node you are running!

* Debian nodejs 0.6.19 is linked with libv8 3.8.9.20.
* Upstream nodejs 0.6.19 ships with libv8 3.6.6.25.
* npm+node-gyp will build native modules with the 3.6.6.25 headers by default.
* Load these modules nodejs running 3.8.9.20 and boom!

Ok, not really "boom" most of the time.  But you can see which symbols
WILL break things with the previously mentioned site:
http://www.upstream-tracker.org/versions/v8.html

An example module that I just found today that will not work in Debian
is memwatch.

$ npm install memwatch
... build against 3.6.6.25...
$ nodejs -e "require('memwatch')"
... run against 3.8.9.20
... FAIL TO LOAD

This is due to the V8::IdleNotification signature changing:
http://www.upstream-tracker.org/compat_reports/v8/3.7.12.5_to_3.7.12.6/abi_compat_report.html

0.6.x has poor debugging of such issues.  0.8.x+ has a better error
for what went wrong above.  But if you comment out the
IdleNotification line in the source the module will load IIRC.

This is going to be a continual problem going forward.  Some solutions:

* Build nodejs with the non-shared shipped V8.
* Build nodejs against the exact V8 version nodejs ships or one that
is known to be ABI compatible.
* Work with upstream authors to get a node-gyp that does the right
thing when shared libs are used and/or teach all developers how to
work around this issue.

And just to make it messy, there are probably similar ABI issues for
the other projects in the deps/ dir.

A bit of good news is that a number of the debian/patches are not
needed for 0.9.6 due to moving to allowing shared libs.  But the
problem of node-gyp building against the wrong libs still exists if
you use the very latest V8.  See
http://www.upstream-tracker.org/compat_reports/v8/3.15.11.8_to_3.16.0/abi_compat_report.html

I've partially updated the packaging for newer versions and found all
these problems along the way.  For end users using native modules it's
going to be painful anytime nodejs gets updated.  Everyone has to know
to type "npm rebuild" or similar for all their projects.  Yuck.

Easiest short term solution for some of this is to lock nodejs to the
V8 version it ships with.  This would include updating the current
package to use the older 3.6.6.25 V8 release.  I'm guessing if this is
done then we could update nodejs and v8 more frequently?

How can I help get this update to happen?  I say getting ready to
update to 0.10.x when it comes out is a good target.

-dave



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Wed, 16 Jan 2013 11:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonas Smedegaard <dr@jones.dk>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Wed, 16 Jan 2013 11:03:03 GMT) Full text and rfc822 format available.

Message #66 received at 692312@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: 692312@bugs.debian.org
Subject: Re: [Pkg-javascript-devel] Bug#692312: Issues updating nodejs
Date: Wed, 16 Jan 2013 12:00:49 +0100
[Message part 1 (text/plain, inline)]
Quoting David I. Lehn (2013-01-16 01:12:17)
> I would also like to see nodejs updated and have been working on it a 
> bit.

We all would like to see Nodejs updated.


> I'm kind of amazed that anyone would have to justify upgrading an 
> ancient release because obviously it has to been done at some point.

Noone has to justify.  It will happen - that's not the point here.


> Sooner rather than later I say.  My reasons are performance and newer 
> APIs and docs:

Performance is nice, but ranks as a feature (it is not a bug that 
current packaged Nodejs is slower than has since proven possible).

Changed API may break existing packages currently in Debian.  I do agree 
that those packages should then be upgraded as well, but "working code" 
is of higher concern to me than "shiny code".


That said, I do appreciate your input, David: not commenting on the rest 
simply means I have no comments on those parts - I expect it to be 
valuable input for Jérémy.


> How can I help get this update to happen?  I say getting ready to 
> update to 0.10.x when it comes out is a good target.

Sounds like it would be great if you could join the team and work 
directly on (branches of) our canonical packaging git.

But really I am the wrong one to judge that, as Jérémy is doing all the 
hard work on these packages.

@Jérémy: What do you say - you want a co-maintainer?


 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Wed, 16 Jan 2013 11:15:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jérémy Lal <kapouer@melix.org>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Wed, 16 Jan 2013 11:15:09 GMT) Full text and rfc822 format available.

Message #71 received at 692312@bugs.debian.org (full text, mbox):

From: Jérémy Lal <kapouer@melix.org>
To: 692312@bugs.debian.org
Cc: dlehn@debian.org
Subject: Re: [Pkg-javascript-devel] Bug#692312: Bug#692312: Issues updating nodejs
Date: Wed, 16 Jan 2013 12:13:27 +0100
On 16/01/2013 12:00, Jonas Smedegaard wrote:
> Quoting David I. Lehn (2013-01-16 01:12:17)
>> I would also like to see nodejs updated and have been working on it a 
>> bit.
> 
> We all would like to see Nodejs updated.
> 
> 
>> I'm kind of amazed that anyone would have to justify upgrading an 
>> ancient release because obviously it has to been done at some point.
> 
> Noone has to justify.  It will happen - that's not the point here.
> 
> 
>> Sooner rather than later I say.  My reasons are performance and newer 
>> APIs and docs:
> 
> Performance is nice, but ranks as a feature (it is not a bug that 
> current packaged Nodejs is slower than has since proven possible).
> 
> Changed API may break existing packages currently in Debian.  I do agree 
> that those packages should then be upgraded as well, but "working code" 
> is of higher concern to me than "shiny code".
> 
> 
> That said, I do appreciate your input, David: not commenting on the rest 
> simply means I have no comments on those parts - I expect it to be 
> valuable input for Jérémy.
> 
> 
>> How can I help get this update to happen?  I say getting ready to 
>> update to 0.10.x when it comes out is a good target.
> 
> Sounds like it would be great if you could join the team and work 
> directly on (branches of) our canonical packaging git.
> 
> But really I am the wrong one to judge that, as Jérémy is doing all the 
> hard work on these packages.
> 
> @Jérémy: What do you say - you want a co-maintainer?

Sure, let's start by finding an agreement on how to deal with node-gyp.

My concern is about node-gyp downloading what it needs to compile : that
is not how i see the debian package of node-gyp should work.
node-gyp should depend on (or recommend) nodejs-dev, which in turn depend
on libv8-dev (and other needed *-dev packages).
This means node-gyp in debian will only output an error if the engine version
in package.json is different than the one currently available.

Jérémy.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>:
Bug#692312; Package nodejs. (Sun, 03 Feb 2013 14:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jan Wagner <waja@cyconet.org>:
Extra info received and forwarded to list. Copy sent to Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>. (Sun, 03 Feb 2013 14:21:03 GMT) Full text and rfc822 format available.

Message #76 received at 692312@bugs.debian.org (full text, mbox):

From: Jan Wagner <waja@cyconet.org>
To: 692312@bugs.debian.org
Subject: Re: nodejs package is out-of-date
Date: Sun, 03 Feb 2013 15:18:41 +0100
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Hi there,

Am 04.11.2012 22:19, schrieb C Snover:
> The current upstream version of nodejs is 0.8.14, but the version 
> currently packaged for Debian is 0.6.19. There are some API changes
> between these versions that prevent new nodejs packages from
> functioning with the version of nodejs currently provided by 
> Debian. At this point, I am required to either install from an 
> Ubuntu PPA or compile from source in order to use nodejs on 
> Debian.

maybe you chould adopt some work from
https://launchpad.net/~chris-lea/+archive/node.js/ when its time to
consider updating nodejs in unstable.

Just my 2 euro cents, Jan.
- -- 
Never write mail to <waja@spamfalle.info>, you have been warned!
- -----BEGIN GEEK CODE BLOCK-----
Version: 3.12
GIT d-- s+: a C+++ UL++++ P+ L+++ E--- W+++ N+++ o++ K++ w--- O M V-
PS PE Y++
PGP++ t-- 5 X R tv- b+ DI D+ G++ e++ h---- r+++ y++++
- ------END GEEK CODE BLOCK------
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iD8DBQFRDnHB9u6Dud+QFyQRAkhYAJ9r7VKMs+QMNq9MJ5ulqOPYYO0TLgCdGXlj
kLdsiiUe3gvf/iV26e3Nh4Q=
=7cdP
-----END PGP SIGNATURE-----



Reply sent to "Jean-Michel Vourgère" <jmv_deb@nirgal.com>:
You have taken responsibility. (Wed, 21 Aug 2013 14:42:05 GMT) Full text and rfc822 format available.

Notification sent to C Snover <debian-bugs@zetafleet.com>:
Bug acknowledged by developer. (Wed, 21 Aug 2013 14:42:05 GMT) Full text and rfc822 format available.

Message #81 received at 692312-done@bugs.debian.org (full text, mbox):

From: "Jean-Michel Vourgère" <jmv_deb@nirgal.com>
To: 692312-done@bugs.debian.org
Subject: Re: nodejs package is out-of-date
Date: Wed, 21 Aug 2013 14:38:47 +0000
C Snover wrote:
> The current upstream version of nodejs is 0.8.14, but the version
> currently packaged for Debian is 0.6.19.
> Please consider updating the currently packaged version to the
> latest upstream release.

Version 0.10 is now in unstable. Therefore I'm closing this bug.


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Sun, 28 Jul 2013 18:50:13 +0200
Source: nodejs
Binary: nodejs-dev nodejs nodejs-dbg nodejs-legacy
Architecture: source all amd64
Version: 0.10.13~dfsg1-2
Distribution: unstable
Urgency: low
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Changed-By: Jérémy Lal <kapouer@melix.org>
Description: 
 nodejs     - evented I/O for V8 javascript
 nodejs-dbg - evented I/O for V8 javascript (debug)
 nodejs-dev - evented I/O for V8 javascript (development files)
 nodejs-legacy - evented I/O for V8 javascript (legacy symlink)
Changes: 
 nodejs (0.10.13~dfsg1-2) unstable; urgency=low
 .
   [ Jérémy Lal ]
   * Fix kfreebsd build:
     + Depend on libkvm-dev on kfreebsd systems.
     + Tighten to build-depend on gyp versions that builds using flock.
     + Add patch 2012 to add __FreeBSD_kernel__ defines.
     + Add patch 1001 readFile not throwing EISDIR on some archs.
     + Add patches 1002, 1003 to fix bugs in unit tests.
     + Set gyp flavor in rules file using --dest-os switch.
   * Restrict make check target in rules to avoid the call to jslint.
 .
   [ Jonas Smedegaard ]
   * Make ~dfsg version suffix only optionally numbered.
   * Stop breaking packages depending on old node binary: None of the
     affected packages exist in any Debian suite since about a year.
   * Declare all package relations except same-source ones in rules file.
   * Add notes in rules file about reasons for versioned dependencies.
   * Drop NEWS file: Contains only entries for versions older than
     existing in any Debian suite since about a year.
   * Rewrite short and long descriptions based on upstream texts.
   * Bump standards-version to 3.9.4.
Checksums-Sha1: 
 5778c830bf2d2267a5a151827a3159d6c2d3dff9 2349 nodejs_0.10.13~dfsg1-2.dsc
 b4cb6be6724ebbebbfdfeada215281583301baa9 37230 nodejs_0.10.13~dfsg1-2.debian.tar.gz
 5ade46c548466edaf3956c0de9e1087fe2275362 70024 nodejs-legacy_0.10.13~dfsg1-2_all.deb
 913546cac913a396d01edbf31226d632d3e7d5c5 232508 nodejs-dev_0.10.13~dfsg1-2_amd64.deb
 3cf512bef79b0d85bdaeada509e94755889aab65 721828 nodejs_0.10.13~dfsg1-2_amd64.deb
 749c02ec0b478ceed18d05d03cf1431dcd5b3996 1004300 nodejs-dbg_0.10.13~dfsg1-2_amd64.deb
Checksums-Sha256: 
 b42b3514ac7acc6990b4ba705fc362187624d58f14bda55e0a9db58b4b42e030 2349 nodejs_0.10.13~dfsg1-2.dsc
 8d6e321365a707c175dfaef79a944adf80d81713d2365693f847b8029976b972 37230 nodejs_0.10.13~dfsg1-2.debian.tar.gz
 88cebca4f4e7abd19bea94b27a8721473f7f2c3e458fd3a8d6632fcaf299e4da 70024 nodejs-legacy_0.10.13~dfsg1-2_all.deb
 7265edc1d6faca4a142f9e17bb986d8acf24188c73514b588400480626cd7d7e 232508 nodejs-dev_0.10.13~dfsg1-2_amd64.deb
 6578a8c287d92fae90afbd5698855fdd97b8886d97b0bd0ccde78f5cfa8a5d65 721828 nodejs_0.10.13~dfsg1-2_amd64.deb
 43b879e212c703dc16324e2a466aa1b1c45f948252271f122138c7ec2213c48f 1004300 nodejs-dbg_0.10.13~dfsg1-2_amd64.deb
Files: 
 288dff58ebc53c80a0e9f11550cfd765 2349 web extra nodejs_0.10.13~dfsg1-2.dsc
 85c62eda2094ecaaa42ec3bc7948098c 37230 web extra nodejs_0.10.13~dfsg1-2.debian.tar.gz
 c673938e4b9705e5f19dffc7eafac05e 70024 web extra nodejs-legacy_0.10.13~dfsg1-2_all.deb
 049cf493bdf8dbe6940d4c87daa849fd 232508 devel extra nodejs-dev_0.10.13~dfsg1-2_amd64.deb
 e6547a0682129170debdd87882339582 721828 web extra nodejs_0.10.13~dfsg1-2_amd64.deb
 09fc4fef7a1c7cac12129c6555c1cafb 1004300 debug extra nodejs-dbg_0.10.13~dfsg1-2_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.14 (GNU/Linux)

iQIcBAEBCAAGBQJR9U1FAAoJEGYRwF7dOfN0pMQP/iAv0oGKhCwzSV6jAsGGqWh2
NY0Y5m6knKzG4UDTHMJU/3PpeREjCzdC8jYy8+Sg4cIQDO0U4sOHQeBG2YFsv7VS
0/FvXyTgzFg6AO6gh+ljY3NWsQZV+IB4ImDIF89KBG4xi7a6CDjxarLK9DPdpUST
X1iwzXxwYwinniKQZfIvQiEy8ZQg+WTmAUaIcgtwVaPVcC3hSe4ZD/zTCZJ514k0
sgeFicCWiwc2KGDeF6D9PwyU5YTWBd2SarQb5nwtxaGbAcEvM8qSssbgzUSfHty4
q4yioSC5iyezfwatkP6ZzMTDjE1IUxMuYGIQhKzNbg/EoIpn1ABkhjx3DlO72+k9
2w4xstoi5NSuM3zQ9fa5mvPFe7+qGC43PcvBQRvNmj94mpty7xy1yq1ZUcnZ39pD
jf2nGLyPI7pg92ihWwusGLAssjjVcVZ7nLzjD1B3PeldkrUJlYdLuanSTtjexWCK
1wBOnL21526BkUc0HZ0WaO10UBJ59c4vE3zhGjjALmJngIb3BnjLmRtjz4RA3ZYG
uSST4ItMBZD86l3NGs1fM1rhCXiTwhKpAZ0i2jP5lUe/uo4YDTi3lqxDT70EdaL5
z1RjK3hzXo3Y6Dib/OYlONpID6h5taDqnslIESSNXtce3tqHP7+wS0BezoNL8W+x
Gpg49PvtfSyKTiAq2lXS
=ts1U
-----END PGP SIGNATURE-----



Reply sent to "Jean-Michel Vourgère" <jmv_deb@nirgal.com>:
You have taken responsibility. (Wed, 21 Aug 2013 14:42:06 GMT) Full text and rfc822 format available.

Notification sent to Csillag <csillag.kristof@gmail.com>:
Bug acknowledged by developer. (Wed, 21 Aug 2013 14:42:06 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 19 Sep 2013 07:26:40 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 06:15:02 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.